package com.hzya.frame.plugin.a8bill.plugin;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.plugin.a8bill.dao.IPayBillPluginInitializerDao;
import com.hzya.frame.plugin.a8bill.entity.PayBillEntity;
import com.hzya.frame.plugin.a8bill.util.NingBBankUtil;
import com.hzya.frame.seeyon.paybill.service.IPayBillService;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * 堃博OA单据推送宁波银行
 *
 * @author makejava
 * @since 2024年7月10日14:13:18
 */
public class KunBPayBillPluginInitializer extends PluginBaseEntity{
    Logger logger = LoggerFactory.getLogger(KunBPayBillPluginInitializer.class);
   @Autowired
   private IPayBillService payBillService;
    @Resource
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;
    @Autowired
    private IPayBillPluginInitializerDao payBillDao;
      @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "KunBPayBillPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "堃博OA付款单同步宁波银行";
    }

    @Override
    public String getPluginLabel() {
        return "KunBPayBillPluginInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        JSONObject requestJsonObj  = JSON.parseObject(requestJson.toString(),JSONObject.class);
        String interId = requestJsonObj.getString("integration_task_living_details_id");
        IntegrationTaskLivingDetailsEntity oldMsg = new IntegrationTaskLivingDetailsEntity();
        if(StrUtil.isNotEmpty(interId)){
            oldMsg = taskLivingDetailsService.get(interId);
        }
        String rootAppPk = oldMsg.getRootAppPk();

        try {
            StringBuffer sb = new StringBuffer();
            if(StrUtil.isNotEmpty(rootAppPk)){
                String code = requestJson.getString("code");
                sb.append(" and id = '"+rootAppPk+"'");
            }else{
                sb.append(" and subState is null");
            }

            PayBillEntity oaBillEntity = new PayBillEntity();
            String dataSourceCode = "KUNBOA";
            oaBillEntity.setDataSourceCode(dataSourceCode);
            StringBuffer stringBuffer = new StringBuffer();

                    //备用金申请单
            stringBuffer.append("select * from v_hzya_pay" );
            stringBuffer.append(sb.toString());
            List<HashMap<String, Object>> hashMaps = payBillDao.getOaBillData(stringBuffer.toString(),oaBillEntity);
            if(CollectionUtils.isNotEmpty(hashMaps)){
                for (HashMap<String, Object> hashMap : hashMaps) {
                    JSONObject main = new JSONObject();
                    for(String key:hashMap.keySet()) {
                        main.put(key, hashMap.get(key));
                    }
                    logger.info("获取到付款单的数据"+main.toString());
                    String apiCode = "8000310000";
                    String result = NingBBankUtil.sendU9cTOCrmEsb(main.toString(),apiCode);
                    logger.info("推送宁波银行的返回结果"+result);
                    IntegrationTaskLivingDetailsEntity logDetails = new IntegrationTaskLivingDetailsEntity();
                    logDetails.setRootAppPk(main.getString("id"));
                    logDetails.setRootAppBill(main.getString("serialNo"));
                    logDetails.setNewTransmitInfo(result);
                    logDetails.setNewPushDate(new Date());
                    logDetails.setRootAppNewData(JSON.toJSONString(main));
                    logDetails.setPluginId("KunBPayBillPluginInitializer");
                    JSONObject resultObj = JSON.parseObject(result);
                    String attribute = resultObj.getString("attribute");
                    boolean flag = resultObj.getBoolean("flag");
                    String subState = "";
                    String fieldName = main.getString("fieldName");
                    String tableName = main.getString("tableName");
                    String payMsg = main.getString("payMsg");
                    String str = "";
                    String sync_flag = "";
                    try {
                        if(StrUtil.isEmpty(interId)){//todo 银行状态 1支付中 2 支付失败 null 未提交支付 0支付成功
                            if(flag){
                                subState = "1";
                                sync_flag = " ,"+payMsg+" = '支付中'";
                                taskLivingDetailsService.saveLogToSuccess(logDetails);
                            }else{
                                subState = "2";
                                taskLivingDetailsService.saveLogToFail(logDetails);
                            }
                        }else{
                            logDetails.setId(interId);
                            if(flag){
                                subState = "1";
                                sync_flag = " ,"+payMsg+" = '支付中'";
                                taskLivingDetailsService.saveLogFailToSuccess(logDetails);
                            }else{
                                subState = "2";
                                taskLivingDetailsService.updateLogFailToSuccess(logDetails);
                            }
                        }

                        str = "update "+tableName+" set " + fieldName + "= '" +subState+"'," +"subMsg = '"+attribute+"'"+sync_flag+"where id = '"+main.getString("id")+"'";
                    } catch (Exception e) {
                        subState = "N";
                        str = "update "+tableName+" set " + fieldName + "= '" +subState+"'," +"subMsg = '"+attribute+"' "+"where id = '"+main.getString("id")+"'";
                        logger.info("保存日志失败"+e.getMessage());
                        oaBillEntity.setSql(str);
                        payBillDao.updateStateForId(str,oaBillEntity);
                        e.printStackTrace();
                    }
                    //修改推送状态，防止重复推送
                    oaBillEntity.setSql(str);
                    payBillDao.updateStateForId(str,oaBillEntity);
                }
            }
        } catch (Exception e) {
            logger.info("获取OA数据失败"+e.getMessage());
            e.printStackTrace();
        }
         return new JsonResultEntity("成功",true,new JsonResultEntity());
    }
}
